"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = __importStar(require("@agile-ts/core"));
const vue_1 = __importDefault(require("vue"));
const bindAgileInstances_1 = require("./bindAgileInstances");
const vueIntegration = new core_1.Integration({
    key: 'vue',
    frameworkInstance: vue_1.default,
    updateMethod: (componentInstance, updatedData) => {
        const componentData = componentInstance.$data;
        for (const key of Object.keys(updatedData)) {
            if (Object.prototype.hasOwnProperty.call(componentData, key)) {
                componentData.sharedState[key] = updatedData[key];
            }
            else {
                vue_1.default.set(componentData.sharedState, key, updatedData[key]);
            }
        }
    },
    bind: (agile) => {
        vue_1.default.use({
            install: (vue) => {
                vue.mixin({
                    created: function () {
                        this.$agile = agile;
                    },
                    methods: {
                        bindAgileInstances: function (deps) {
                            var _a;
                            return {
                                sharedState: Object.assign(Object.assign({}, (((_a = this === null || this === void 0 ? void 0 : this.$data) === null || _a === void 0 ? void 0 : _a.sharedState) || {})), bindAgileInstances_1.bindAgileInstances(deps, agile, this)),
                            };
                        },
                        bindAgileValues: function (deps) {
                            var _a;
                            return {
                                sharedState: Object.assign(Object.assign({}, (((_a = this === null || this === void 0 ? void 0 : this.$data) === null || _a === void 0 ? void 0 : _a.sharedState) || {})), bindAgileInstances_1.bindAgileInstances(deps, agile, this, 'value')),
                            };
                        },
                        bindAgileOutputs: function (deps) {
                            var _a;
                            return {
                                sharedState: Object.assign(Object.assign({}, (((_a = this === null || this === void 0 ? void 0 : this.$data) === null || _a === void 0 ? void 0 : _a.sharedState) || {})), bindAgileInstances_1.bindAgileInstances(deps, agile, this, 'output')),
                            };
                        },
                    },
                });
            },
        });
        return Promise.resolve(true);
    },
});
core_1.default.initialIntegrations.push(vueIntegration);
exports.default = vueIntegration;
